<template>
  <ElCard class="form">
    <ElForm v-bind:model="formData" ref="formRef" :rules="rules">
      <ElFormItem label="Тип операции" prop="type">
        <ElSelect
          class="type-select"
          v-model="formData.type"
          placeholder="Выберите тип операции"
        >
          <ElOption lable="INCOME" value="Поступление" />
          <ElOption lable="OUTCOME" value="Расход" />
        </ElSelect>
      </ElFormItem>

      <ElFormItem label="Комментарий" prop="comment">
        <ElInput v-model="formData.comment" placeholder="Введите комментарий" />
      </ElFormItem>

      <ElFormItem label="Сумма" prop="value">
        <!-- Значение сразу приводится к числу с помощью V-model.number -->
        <ElInput v-model.number="formData.value" />
      </ElFormItem>

      <ElButton type="primary" @click="processForm">Добавить</ElButton>
    </ElForm>
  </ElCard>
</template>

<script>
export default {
  name: "Form",

  data: () => ({
    formData: {
      type: "",
      comment: "",
      value: 0,
    },

    // Валидация формы
    rules: {
      type: [
        { required: true, message: "Выберите тип операции", trigger: "change" }, // trigger: когда триггерить проверку
      ],
      comment: [
        { required: true, message: "Введите комментарий", trigger: "change" },
      ],
      value: [
        { required: true, message: "Введите сумму", trigger: "change" },
        { type: "number", message: "Нужно ввести число", trigger: "change" },
      ],
    },
  }),
  methods: {
    processForm() {
      this.$refs["formRef"].validate((valid) => {
        if (valid) {
          if (this.formData.type === "Расход" && this.formData.value > 0) {
            this.formData.value = this.formData.value * -1;
          }
          this.$emit("submitForm", { ...this.formData });
          this.$refs["formRef"].resetFields();
        }
      });
    },
  },
};
</script>

<style scoped>
.form {
  max-width: 500px;
  margin: auto;
}
.type-select {
  width: 100%;
}
</style>
